abuild.in 47.3 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# abuild - build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#

Natanael Copa's avatar
Natanael Copa committed
9 10
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
11
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
12
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
13

14
program=${0##*/}
15
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
16 17

# defaults
18
BUILD_BASE="build-base"
19
FAKEROOT=${FAKEROOT:-"fakeroot"}
20

21 22
: ${SUDO_APK:=abuild-apk}
: ${APK:=apk}
23 24 25
: ${ADDUSER:=abuild-adduser}
: ${ADDGROUP:=abuild-addgroup}

26
apk_opt_wait="--wait 30"
27

Natanael Copa's avatar
Natanael Copa committed
28
# read config
Natanael Copa's avatar
Natanael Copa committed
29
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
30 31
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

32
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
33 34 35 36 37 38
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
39 40 41 42 43 44 45 46 47 48 49 50 51 52
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
53 54 55 56 57 58 59
fi

# run optional log command for remote logging
logcmd() {
	${ABUILD_LOG_CMD:-true} "$@"
	return 0
}
Natanael Copa's avatar
Natanael Copa committed
60 61 62

# functions
msg() {
63
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
64 65 66
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
67 68 69 70 71 72 73
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

msg2() {
	[ -n "$quiet" ] && return 0
	#      ">>> %s"
	printf "    %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
74 75 76 77 78 79
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
80 81 82 83
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

warning2() {
84
	#      ">>> WARNING:
85
	printf "             %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
86 87 88 89 90 91
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
92
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
93
	logcmd "ERROR: $pkgname: $1"
94 95 96
}

error2() {
97
	#      ">>> ERROR:
98
	printf "           %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
99
}
100

Linux User's avatar
Linux User committed
101
set_xterm_title() {
102
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
103
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
104
	fi
105
}
Linux User's avatar
Linux User committed
106 107

cleanup() {
108
	local i=
Linux User's avatar
Linux User committed
109
	set_xterm_title ""
110 111 112
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
113 114 115 116 117 118 119 120 121 122 123 124 125
	for i; do
		case $i in
		pkgdir) msg "Cleaning up pkgdir"; rm -rf "$pkgbasedir";;
		srcdir) msg "Cleaning up srcdir"; rm -rf "$srcdir";;
		deps)
			if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
				msg "Uninstalling dependencies..."
				$SUDO_APK del --quiet $apk_opt_wait \
					$uninstall_after
			fi
			;;
		esac
	done
Linux User's avatar
Linux User committed
126 127
}

Natanael Copa's avatar
Natanael Copa committed
128
die() {
Linux User's avatar
Linux User committed
129
	error "$@"
130
	cleanup $ERROR_CLEANUP
Natanael Copa's avatar
Natanael Copa committed
131 132 133
	exit 1
}

134 135 136 137
spell_error() {
	die "APKBUILD contains '$1'. It should be '$2'"
}

138
# check if apkbuild is basicly sane
139
default_sanitycheck() {
140
	local i= j= suggestion=
141
	msg "Checking sanity of $APKBUILD..."
142 143 144
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
145
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
146
		$APK version --check --quiet "$pkgver" ||\
147 148
			die "$pkgver is not a valid version"
	fi
149
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
150 151 152
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"
153 154 155
	if [ $(echo "$pkgdesc" | wc -c) -gt 128 ]; then
		die "pkgdesc is too long"
	fi
156
	is_function package || warning "Missing package() function in APKBUILD"
157

158 159
	if [ -n "$replaces_priority" ] \
		&& ! echo $replaces_priority | egrep -q '^[0-9]+$'; then
160 161
		die "replaces_priority must be a number"
	fi
162 163 164 165 166 167 168
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
		-*) die "${i%:*} is not a valid package name";;
		esac
	done

169
	# check if CARCH, CBUILD, CHOST and CTARGET is set
170 171
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

172
	if [ -z "$CARCH" ]; then
Natanael Copa's avatar
Natanael Copa committed
173
		die "Please fix CHOST, or set CARCH in abuild.conf"
174
	fi
175

Natanael Copa's avatar
Natanael Copa committed
176
	for i in $install; do
177
		local n=${i%.*}
178
		local suff=${i##*.}
179 180 181 182 183
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
184
			die "$i: install script does not match pkgname or any subpackage"
185
		fi
186
		[ -e "$startdir/$i" ] || die "install script $i is missing"
187 188 189 190 191 192
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
193
	done
194

195 196 197
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
198
		[ "$f" = "$i" ] && die "$f: triggers must contain '='"
199 200 201 202
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
203

204 205
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
206 207
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
208 209 210 211
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
212
			case "$i" in
213
				*::*) i=${i%%::*};;
214
				https://*) makedepends_has wget && warning "wget no longer need to be in makedepends when source has https://" ;;
215
			esac
216 217
			list_has ${i##*/} $md5sums $sha256sums $sha512sums \
				|| die "${i##*/} is missing in checksums"
218 219
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
220

221 222 223 224 225 226 227 228
	# verify that things listed in checksum also is listed in source
	local algo=
	for algo in md5 sha256 sha512; do
		eval set -- \$${algo}sums
		while [ $# -gt 1 ]; do
			local file="$2"
			shift 2
			source_has $file || die "$file exists in ${algo}sums but is missing in source"
229
		done
230
	done
231

232
	# common spelling errors
233 234 235 236 237
	[ -n "$depend" ] && spell_error depend depends
	[ -n "$makedepend" ] && spell_error makedepend makedepends
	[ -n "$pkguser" ] && spell_error pkguser pkgusers
	[ -n "$pkggroup" ] && spell_error pkggroup pkggroups
	[ -n "$subpackage" ] && spell_error subpackage subpackages
Natanael Copa's avatar
Natanael Copa committed
238 239

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
240 241

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
242 243 244
	return 0
}

245 246 247 248
sanitycheck() {
	default_sanitycheck
}

249 250
sumcheck() {
	local algo="$1" sums="$2"
251
	local dummy f endreturnval originalparams origin file
252 253 254 255 256 257 258 259

	# get number of checksums
	set -- $sums
	local numsums=$(( $# / 2 ))

	set -- $source
	if [ $# -ne $numsums ]; then
		die "Number of ${algo}sums($numsums) does not correspond to number of sources($#)"
260
	fi
261
	fetch || return 1
262
	msg "Checking ${algo}sums..."
Natanael Copa's avatar
Natanael Copa committed
263
	cd "$srcdir" || return 1
264 265
	IFS=$'\n'
	endreturnval=0
266
	for src in $sums; do
267
		origin=$1; shift
268
		echo "$src" | ${algo}sum -c
269
		if [ $? -ne 0 ]; then
270
			endreturnval=1
271
			is_remote $origin || continue
272
			echo "Because the remote file above failed the ${algo}sum check it will be deleted."
273 274 275 276 277 278 279 280
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
281 282
}

283 284 285 286 287 288 289 290 291
# for compatibility
md5check() {
	warning "'md5check' is deprecated. Use 'verify' instead"
	sumcheck md5 "$md5sums"
}

# verify checksums
verify() {
	local verified=false algo=
292
	for algo in sha512 sha256 sha1 md5; do
293 294 295 296 297 298 299
		local sums=
		eval sums=\"\$${algo}sums\"
		if [ -z "$sums" ] || [ -z "$source" ]; then
			continue
		fi
		sumcheck "$algo" "$sums" || return 1
		verified=true
300
		break
301 302 303 304 305 306 307
	done
	if [ -n "$source" ] && ! $verified; then
		die "Use 'abuild checksum' to generate/update the checksum(s)"
	fi
	return 0
}

308 309
# verify upstream sources
sourcecheck() {
310 311 312 313 314 315 316 317
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
318 319 320
		*::*)
			uri=${uri##*::}
			;;
321 322
		esac
		wget -q -s "$uri" || return 1
323
	done
324
	return 0
325
}
326

327 328 329
# convert curl options to wget options and call wget instead of curl
wget_fallback() {
	local wget_opts= outfile= opt=
330
	while getopts "C:Lko:s" opt; do
331
		case $opt in
332
		'L') ;; # --location. wget does this by default
333
		'f') ;; # --fail. wget does this by default
334 335 336 337 338 339 340 341 342 343
		'C') wget_opts="$wget_opts -c";; # --continue-at
		's') wget_opts="$wget_opts -q";; # --silent
		'o') wget_opts="$wget_opts -O $OPTARG";; # --output
		'k') wget_opts="$wget_opts --no-check-certificate";; #gnu wget
		esac
	done
	shift $(( $OPTIND - 1 ))
	wget $wget_opts "$1"
}

Natanael Copa's avatar
Natanael Copa committed
344 345
uri_fetch() {
	local uri="$1"
346
	local d="${uri##*/}"	# $(basename $uri)
347
	local opts
348
	[ -n "$quiet" ] && opts="-s"
349 350

	local lockfile="$SRCDEST/$d".lock
351

352 353 354 355 356
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
357 358 359 360 361

		*::*)
			d=${uri%%::*}
			uri=${uri#$d::}
			;;
362
	esac
363 364

	case "$uri" in
365
		https://*) opts="-k";;
366
	esac
367

Natanael Copa's avatar
Natanael Copa committed
368
	mkdir -p "$SRCDEST"
369 370 371

	CLEANUP_FILES="$CLEANUP_FILES $lockfile"
	(
372 373
	flock -n -x 9 || msg "Waiting for ${lockfile##*/}..."
	flock -x 9
374 375 376

	[ -f "$SRCDEST/$d" ] && exit 0 # use exit since its a subshell

377 378
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
379
		opts="$opts -C -"
Natanael Copa's avatar
Natanael Copa committed
380
	fi
Linux User's avatar
Linux User committed
381
	msg "Fetching $uri"
382 383

	# fallback to wget if curl is missing. useful for bootstrapping
384
	local fetcher=
385 386
	if ! [ -x "$(which curl)" ]; then
		fetcher=wget_fallback
387 388
	else
		fetcher=curl
389
		opts="$opts -L -f -k"
390 391 392
	fi

	$fetcher $opts -o "$SRCDEST/$d.part" "$uri" \
393
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
394

395
	) 9>$lockfile
396 397 398 399

	local rc=$?
	rm -f "$lockfile"
	return $rc
Natanael Copa's avatar
Natanael Copa committed
400 401
}

402
is_remote() {
403
	case "${1#*::}" in
404
		http://*|ftp://*|https://*|saveas-*://*)
405 406 407 408 409
			return 0;;
	esac
	return 1
}

410 411 412 413 414 415 416 417 418
filename_from_uri() {
	local uri="$1"
	local filename="${uri##*/}"  # $(basename $uri)
	case "$uri" in
	*::*) filename=${uri%%::*};;
	esac
	echo "$filename"
}

419 420 421 422
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	if [ -n "$DISTFILES_MIRROR" ]; then
423
		if is_remote "$DISTFILES_MIRROR"; then
424 425
			uri_fetch "$DISTFILES_MIRROR"/$(filename_from_uri $uri)\
				&& return 0
426
		else
427 428
			cp "$DISTFILES_MIRROR"/$(filename_from_uri $uri) \
				"$SRCDEST" && return 0
429
		fi
430 431 432 433
	fi
	uri_fetch "$uri"
}

434
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
435 436
	local s
	mkdir -p "$srcdir"
437 438
	for s in $source; do
		if is_remote "$s"; then
439
			uri_fetch_mirror "$s" || return 1
440
			ln -sf "$SRCDEST/$(filename_from_uri $s)" "$srcdir"/
441
		else
442 443
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
444 445 446
	done
}

447 448 449 450
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
451 452 453 454 455 456 457 458 459 460 461 462
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
463
	done
Natanael Copa's avatar
Natanael Copa committed
464 465
}

Natanael Copa's avatar
Natanael Copa committed
466
# unpack the sources
467
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
468
	local u
469
	if [ -z "$force" ]; then
470
		verify || return 1
Natanael Copa's avatar
Natanael Copa committed
471
		initdcheck || return 1
472
	fi
Natanael Copa's avatar
Natanael Copa committed
473 474
	mkdir -p "$srcdir"
	for u in $source; do
475
		local s="$SRCDEST/$(filename_from_uri $u)"
Natanael Copa's avatar
Natanael Copa committed
476
		case "$s" in
477 478 479
			*.tar)
				msg "Unpacking $s..."
				tar -C "$srcdir" -xf "$s" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
480
			*.tar.gz|*.tgz)
481
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
482 483
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
484
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
485
				tar -C "$srcdir" -jxf "$s" || return 1;;
486 487 488 489
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
490 491 492
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
493 494 495
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
496 497 498 499
		esac
	done
}

500 501 502 503
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
504 505
# cleanup source and package dir
clean() {
506
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
507
	rm -rf "$srcdir"
508
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
509 510 511 512 513 514
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
515
		if is_remote "$s"; then
516 517 518
			s=$(filename_from_uri $s)
			msg "Cleaning downloaded $s ..."
			rm -f "$SRCDEST/$s"
519
		fi
Natanael Copa's avatar
Natanael Copa committed
520 521 522
	done
}

523 524 525 526 527 528 529 530 531 532
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
533 534
cleanpkg() {
	local i
535
	getpkgver || return 1
536
	msg "Cleaning built packages..."
537
	for i in $(listpkgnames); do
538 539
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
540
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
541
	done
542
	# remove given packages from index
543
	update_abuildrepo_index
Natanael Copa's avatar
Natanael Copa committed
544 545
}

546 547 548
# clean all packages except current
cleanoldpkg() {
	local i j
549
	getpkgver || return 1
550
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
551
	for i in $(listpkgnames); do
552 553 554 555 556
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
557 558 559 560
		done
	done
	return 0
}
561 562 563

mkusers() {
	local i
564 565 566 567 568 569
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$ADDGROUP -S $i || return 1
		fi
	done
570 571
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
572
			local gopt=
573
			msg "Creating user $i"
574 575 576
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
577
			$ADDUSER -S -D -H $gopt $i || return 1
578 579 580 581
		fi
	done
}

Natanael Copa's avatar
Natanael Copa committed
582 583
# helper to update config.sub to a recent version
update_config_sub() {
584
	local changed=false
Natanael Copa's avatar
Natanael Copa committed
585
	find . -name config.sub | while read f; do
586 587
		if ! ./$f armv6-alpine-linux-muslgnueabihf 2>/dev/null; then
			msg "Updating $f"
588 589 590
			cp "$datadir"/${f##*/} "$f" || return 1
			changed=true
		else
591
			msg "Not new enough $f"
592 593 594
		fi
		# pipe subshell will return status of last command
		$changed
Natanael Copa's avatar
Natanael Copa committed
595
	done
596
	return $?
Natanael Copa's avatar
Natanael Copa committed
597
}
598

Natanael Copa's avatar
Natanael Copa committed
599 600
runpart() {
	local part=$1
601
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
602 603 604 605
	$part || die "$part failed"
}

# override those in your build script
606 607 608 609 610 611 612 613
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
614 615 616 617
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
618
build() {
619
	:
Natanael Copa's avatar
Natanael Copa committed
620 621
}

622 623 624
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
625
	mkdir -p "$PKGDEST"
626 627 628
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

629 630 631 632 633 634 635 636 637
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

638 639 640
postcheck() {
	local dir="$1" name="$2" i=
	msg "Running postcheck for $name"
641
	# checking for FHS compat
Natanael Copa's avatar
Natanael Copa committed
642 643 644 645 646 647 648 649
	if ! options_has "!fhs"; then
		for i in "$dir"/srv/* "$dir"/usr/local/* "$dir"/opt/*; do
			if [ -e "$i" ]; then
				error "Packages must not put anything under /srv, /usr/local or /opt"
				return 1
			fi
		done
	fi
650 651 652 653 654 655 656
	# look for *.la files
	i=$(find "$dir" -name '*.la' | sed "s|^$dir|\t|")
	if [ -n "$i" ] && ! options_has "libtool"; then
		error "Libtool archives (*.la) files found and \$options has no 'libtool' flag:"
		echo "$i"
		return 1
	fi
657 658 659 660 661 662
	# look for /usr/lib/charset.alias
	if [ -e "$dir"/usr/lib/charset.alias ] \
			&& ! options_has "charset.alias"; then
		error "Found /usr/lib/charset.alias"
		return 1
	fi
663 664 665 666 667 668
	# check directory permissions
	i=$(find "$dir" -type d -perm -777 | sed "s|^$dir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
669
	# check so we dont have any suid root binaries that are not
670 671 672 673 674 675 676 677
	i=$(find "$dir" -type f -perm +6000 \
		| xargs scanelf --nobanner --etype ET_EXEC \
		| sed "s|ET_EXEC $dir|\t|")
	if [ -n "$i" ]; then
		error "Found non-PIE files that has SUID:"
		echo "$i"
		return 1
	fi
678 679 680 681 682 683 684 685 686
	# test for textrels
	if ! options_has "textrels"; then
		local res="$(scanelf --recursive --textrel --quiet "$dir")"
		if [ -n "$res" ]; then
			error "Found textrels:"
			echo "$res"
			return 1
		fi
	fi
687 688 689
	return 0
}

690
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
691 692
	local i
	cd "$startdir"
693
	for i in $subpackages; do
694 695
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
696
		msg "Running split function $func..."
697
		local dir="$pkgbasedir/${i%:*}" name="${i%:*}"
698 699 700
		( subpkgdir="$dir" subpkgname="$name" \
			$0 $func prepare_package \
			&& postcheck "$dir" "$name" ) || return 1
Natanael Copa's avatar
Natanael Copa committed
701
	done
702
	postcheck "$pkgdir" "$pkgname" || return 1
703 704
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
705
		warning "Found /usr/share/locale"
706
		warning2 "Maybe add \$pkgname-lang to subpackages?"
707
	fi
Natanael Copa's avatar
Natanael Copa committed
708 709
}

710
default_lang() {
711
	pkgdesc="Languages for package $pkgname"
712 713 714 715 716 717 718 719 720 721 722 723 724
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

725
default_lang_subpkg() {
726 727 728 729
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
730
	pkgdesc="$pkgname language pack for $lang"
731 732
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
733 734 735 736 737
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
738
		|| return 1
739 740 741 742 743
	done
}

lang_subpkg() {
	default_lang_subpkg
744 745 746 747 748 749 750 751 752 753 754
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

755 756 757 758 759 760 761 762 763 764 765 766
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

767 768 769 770 771 772
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

773
prepare_metafiles() {
774
	getpkgver || return 1
775 776
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
777
	local dir=${subpkgdir:-$pkgdir}
778
	local pkg="$name-$pkgver-r$pkgrel.apk"
779
	local pkginfo="$controldir"/.PKGINFO
780
	local sub
781

Natanael Copa's avatar
Natanael Copa committed
782 783
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
784
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
785 786
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
787
	local parch="$CARCH"
788 789 790 791 792

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
793

794
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
795
	if [ -n "$FAKEROOTKEY" ]; then
796
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
797
	fi
798 799
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
800
pkgname = $name
801
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
802 803 804 805 806
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
807
arch = $parch
808
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
809
EOF
810 811
	local i deps
	deps="$depends"
812
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
813 814
		for i in $install $triggers; do
			local s=${i%=*}
815
			[ "$name" != "${s%.*}" ] && continue
816
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
817 818 819 820 821
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
822
	fi
823

824 825 826
	# store last_commit in global var so we only call git once
	if [ -z "$last_commit" ]; then
		last_commit="$(git_last_commit)$(git_dirty)"
827
	fi
828
	echo "commit = $last_commit" >> "$pkginfo"
829 830 831 832 833 834

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

835
	if [ -n "$replaces_priority" ]; then
836
		echo "replaces_priority = $replaces_priority" >> "$pkginfo"
837 838
	fi

Natanael Copa's avatar
Natanael Copa committed
839
	for i in $license; do
840
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
841 842
	done
	for i in $replaces; do
843
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
844
	done
845
	for i in $deps; do
846
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
847 848
	done
	for i in $conflicts; do
849
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
850 851
	done
	for i in $provides; do
852
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
853
	done
854 855 856 857 858 859
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
860 861 862
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
863 864

	local metafiles=".PKGINFO"
865 866 867
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
868
		if [ "$n" != "$name" ]; then
869 870
			continue
		fi
871
		script=${f#$name}
872
		msg "Adding $script"
873
		cp "$startdir/$f" "$controldir/$script" || return 1
874
		chmod +x "$controldir/$script"
875 876
		metafiles="$metafiles $script"
	done
877
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
878
}
879

880 881
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
882
	local etype= soname= file= sover=
883
	[ "$arch" = "noarch" ] && return 0
884
	options_has "!tracedeps" && return 0
885
	# lets tell all the places we should look for .so files - all rpaths
886 887
	scanelf --quiet --recursive --rpath "$dir" \
		| sed -e 's/[[:space:]].*//' -e 's/:/\n/' | sort -u \
888
		>"$controldir"/.rpaths
889 890 891 892 893 894 895
	if grep -q -x '/usr/lib' "$controldir"/.rpaths; then
		warning "Redundat /usr/lib in rpath found"
	fi
	if grep '^/home/' "$controldir"/.rpaths; then
		error "Has /home/... in rpath"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
896 897
}

898 899 900 901 902 903 904 905 906 907 908 909
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

910 911 912 913 914
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

915 916 917 918 919 920 921
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
922 923 924
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
925 926 927 928
	fi
	return 0
}

929
prepare_package() {
930
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
931
	stripbin
932
	prepare_metafiles && prepare_tracedeps || return 1
933
	archcheck
934 935 936 937 938 939 940 941
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

942 943 944 945 946 947 948 949 950 951 952 953 954 955 956 957 958 959 960 961 962 963 964
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

965 966 967 968
subpkg_provides() {
	grep -q -w "^$1" "$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

969 970 971
trace_apk_deps() {
	local name="$1"
	local dir="$2"
972
	local i= found= autodeps= deppkgs= missing=
973
	msg "Tracing dependencies..."
974 975 976
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
977
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
978 979 980 981
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
982
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
983 984
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
985
		msg "  added libgcc (due to libpthread)"
986
	fi
987
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
988 989 990
		# first check if its provided by same apkbuild
		grep -q -w "^$i" "$dir"/.provides-so 2>/dev/null && continue

991 992
		if subpkg_provides "$i" || [ "$CBUILD" != "$CHOST" ] \
				|| $APK info --quiet --installed "so:$i"; then
993
			autodeps="$autodeps so:$i"
994
		else
995
			missing="$missing $i"
996
		fi
997 998 999
	done

	# find all packages that holds the so files
1000
	if [ -f "$dir"/.rpaths ]; then
1001 1002
		local so_files=$(find_so_files "$dir"/.rpaths $missing) \
			|| return 1
1003
		deppkgs=$($APK info --quiet --who-owns $so_files) || return 1
1004 1005
	fi

1006
	for found in $deppkgs; do
1007
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
1008 1009 1010
			warning "You can remove '$found' from depends"
			continue
		fi
1011
		autodeps="$autodeps $found"
1012
	done
1013

1014
	echo "# automatically detected:" >> "$dir"/.PKGINFO
1015
	if [ -f "$dir"/.provides-so ]; then
1016
		sed 's/^\(.*\) \([0-9].*\)/provides = so:\1=\2/' "$dir"/.provides-so \
1017
			>> "$dir"/.PKGINFO
1018 1019
	fi
	[ -z "$autodeps" ] && return 0
1020
	for i in $autodeps; do
1021 1022
		echo "depend = $i"
	done | sort -u >> "$dir"/.PKGINFO
1023 1024
	# display all depends
	sed -n '/^depend =/s/depend = /\t/p' "$dir"/.PKGINFO >&2
1025 1026
}

1027
find_scanelf_paths() {
1028
	local datadir="$1"
Natanael Copa's avatar
Natanael Copa committed
1029
	local paths="$datadir/lib:$datadir/usr/lib" i= rpaths=
1030
	if [ -n "$ldpath" ]; then
Natanael Copa's avatar
Natanael Copa committed
1031
		paths="$paths:$(echo "${datadir}${ldpath}" | sed "s|:|:$datadir|g")"
1032 1033
	fi
	# search in all rpaths
Natanael Copa's avatar
Natanael Copa committed
1034 1035
	for rpaths in "$pkgbasedir"/.control.*/.rpaths; do
		[ -f "$rpaths" ] || continue
1036
		while read i; do
1037 1038 1039 1040
			local dir="${datadir}${i}"
			IFS=:
			if [ -d "$dir" ] && ! list_has "$dir" $paths; then
				paths="$paths:${dir}"
1041
			fi
1042
			unset IFS
Natanael Copa's avatar
Natanael Copa committed
1043
		done < "$rpaths"
1044 1045 1046 1047 1048 1049
	done
	echo "$paths"
}

scan_shared_objects() {
	local name="$1" controldir="$2" datadir="$3"
1050
	local opt= i=
1051 1052 1053

	# allow spaces in paths
	IFS=:
1054
	set -- $(find_scanelf_paths "$datadir")
1055 1056
	unset IFS

1057 1058 1059 1060 1061 1062 1063 1064
	# sanity check, verify that each path is prefixed with datadir
	for i; do
		if [ "${i#$datadir}" = "$i" ]; then
			error "Internal error in scanelf paths"
			return 1
		fi
	done

1065 1066 1067
	if options_has "ldpath-recursive"; then
		opt="--recursive"
	fi
1068 1069
	msg "Scanning shared objects"
	# lets tell all the .so files this package provides in .provides-so
1070
	scanelf --nobanner --soname $opt "$@" | while read etype soname file; do
1071 1072
		# if soname field is missing, soname will be the filepath
		sover=0
1073 1074
		if [ -z "$file" ]; then
			file="$soname"
1075
			soname=${soname##*/}
1076 1077 1078 1079
		fi

		# we only want shared libs
		case $soname in
1080
		*.so|*.so.[0-9]*|*.c32);;
1081 1082 1083 1084 1085 1086 1087 1088 1089
		*) continue;;
		esac

		case "$file" in
		*.so.[0-9]*) sover=${file##*.so.};;
		*.so)
			# filter out sonames with version when file does not
			# have version
			case "$soname" in
1090 1091 1092 1093
			*.so.[0-9]*)
				if options_has "sover-namecheck"; then
					continue
				fi
1094 1095 1096
			esac
			;;
		esac
Natanael Copa's avatar
Natanael Copa committed
1097
		list_has "$soname" $somask && continue
1098
		echo "$soname $sover"
1099 1100 1101 1102 1103 1104 1105 1106 1107 1108
	# use awk to filter out dupes that has sover = 0
	done | awk '{ if (so[$1] == 0) so[$1] = $2; }
		END { for (i in so) print(i " " so[i]); }' \
		| sort -u > "$controldir"/.provides-so

	# verify that we dont have any duplicates
	local dupes="$(cut -d' ' -f1 "$controldir"/.provides-so | uniq -d)"
	if [ -n "$dupes" ]; then
		die  "provides multiple versions of same shared object: $dupes"
	fi
1109 1110 1111 1112 1113

	# now find the so dependencies
	scanelf --nobanner --recursive --needed